# Argumentative relation classification as plausibility ranking

## General idea

The general idea is not confied to argumentative relation ranking, but any relation which can be epressed in natural language phrase.
The code is for two relation classes though extension to n classes should be possible.

In relation classification we have a SOURCE and a TARGET clause/sentence and a possible label (e.g., attack support). Let's just have an example,

``` 
SOURCE: the better a person feels , the better his brain works 
```

```
TARGET: putting physical activities in early steps of human development would finally lead to mentally healthy society
```

``` 
REL: support
```
From this, we can construct the plausible variant which signals support

```
putting physical activities in early steps of human development would finally lead to mentally healthy society. MOREOVER the better a person feels , the better his brain works
```

And the implausible variant which signals attack (in this case)

```
putting physical activities in early steps of human development would finally lead to mentally healthy society. HOWEVER the better a person feels , the better his brain works
```

## what you need

three files one for training one for dev and one for testing examples in tsv format

```
Some-ID\tabSOURCE-SENTENCE\tabTARGET-SENTENCE\tabLABEL
```

Put the file paths in data_config.py (see inside for an example)

if you want to provide context provide one file which maps the Some-ID to context of source and target:

```
Some-ID\tabSOURCE-CONTEXT\tabTARGET-CONTEXT
```
## to get results with the best model with moreover/however reconstruction and average results over five independent runs

0. install requirements and make directory to save logs and model: mkdir logs & mkdir models
1. adapt paths in data_config.py
2. ./run_essay.sh (if you don't have slurm, just adapt accordingly)
3. evaluate predictions: python run_eval.py

That's it. But here's also an 

###  In-depth explanation of the main run-command example

```
python arg_rel_plausibility_ranker.py ESSAY bert 0 -sup_connect "Moreover+," -att_connect "However+," -maxlen=50 --use_markers
ESSAY: refers to the paths in data_config.py
bert: use bert (or "elmo")... other languade models are easy to integrate thanks to allennlp/huggingface
sup_connect: connector to signal support (you can put anything here what you want, + means whitespave)
att_connect: connector to signal attack (you can put anything here what you want)
use_markers: shall we use marker embeddings to show the model what part of text belongs to src or tgt unit?
```

## FAQ:

Full Argumentaive relation Data: please shoot me an email or download from [TU Darmstadt server](https://www.informatik.tu-darmstadt.de/ukp/research_6/data/argumentation_mining_1/argument_annotated_essays_version_2/index.en.jsp) and prepare the data yourself


## Citation
```
@article{opitz2019argumentative,
  title={Argumentative Relation Classification as Plausibility Ranking},
  author={Opitz, Juri},
  journal={arXiv preprint arXiv:1909.09031},
  year={2019}
}
```
